#pragma once

namespace Jetpack
{
    template<typename T> inline void MessagingManager::RegisterHandler()
    {
        auto handler = std::shared_ptr<T>(new T());
        
        std::list<std::shared_ptr<IMessageHandler>>* list = nullptr;
        
        if ((handler->GetHandleStates() & m_currentHandleState) == 0x0)
        {
            list = &m_deactiveHandlers;
        }
        else
        {
           list = &m_activeHandlers;
        }
        
        list->push_back(handler);
    }
}
